/*
 * This file is part of the Cforall project
 *
 * $Id: DeclStmt.cc,v 1.4 2005/08/29 20:59:25 rcbilson Exp $
 *
 */

#include "Statement.h"
#include "Declaration.h"
#include "utility.h"


DeclStmt::DeclStmt( std::list<Label> labels, Declaration *decl )
    : Statement( labels ), decl( decl )
{
}

DeclStmt::DeclStmt( const DeclStmt &other )
    : Statement( other ), decl( maybeClone( other.decl ) )
{
}

DeclStmt::~DeclStmt()
{
    delete decl;
}

void 
DeclStmt::print( std::ostream &os, int indent )
{
    os << "Declaration of ";
    if( decl ) {
	decl->print( os, indent );
    }
}


