#include "Declaration.h"
#include "Type.h"
#include "utility.h"


TypeDecl::TypeDecl( const std::string &name, StorageClass sc, Type *type, Kind kind )
    : Parent( name, sc, type ), kind( kind )
{
}

TypeDecl::TypeDecl( const TypeDecl &other )
    : Parent( other ), kind( other.kind )
{
}

std::string
TypeDecl::typeString() const
{
    static const char *kindNames[] = { "type", "incomplete type", "function type" };
    return kindNames[ kind ];
}

