/*
 * This file is part of the Cforall project
 *
 * $Id: TypeExpr.cc,v 1.4 2005/08/29 20:59:26 rcbilson Exp $
 *
 */

#include "Expression.h"
#include "Type.h"
#include "utility.h"


TypeExpr::TypeExpr( Type *type )
    : type( type )
{
}

TypeExpr::TypeExpr( const TypeExpr &other )
    : type( maybeClone( other.type ) )
{
}

TypeExpr::~TypeExpr()
{
    delete type;
}

void 
TypeExpr::print( std::ostream &os, int indent ) const
{
    if( type ) type->print( os, indent );
    Expression::print( os, indent );
}

